﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using System.Diagnostics;
using System.IO;
using System.Globalization;
using System.Threading;
using System.Runtime.InteropServices;

namespace photostand
{
    static class Program
    {
        /// <summary>
        /// アプリケーションのメイン エントリ ポイントです。
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            // check culture and set en, if not ja.
            // Thread.CurrentThread.CurrentUICulture = new CultureInfo("en-US", false);
            Debug.WriteLine("Thread.CurrentThread.CurrentUICulture is " + Thread.CurrentThread.CurrentUICulture.Name);
            if (!Thread.CurrentThread.CurrentUICulture.Name.StartsWith("ja") && !Thread.CurrentThread.CurrentUICulture.Name.StartsWith("en")) {
                Debug.WriteLine("Thread.CurrentThread.CurrentUICulture is " + Thread.CurrentThread.CurrentUICulture.Name);
                Thread.CurrentThread.CurrentUICulture = new CultureInfo("en", false);
            }
            Debug.WriteLine("Thread.CurrentThread.CurrentUICulture is " + Thread.CurrentThread.CurrentUICulture.Name);

            // check not to run same processes simultaneously.
            /* if (Process.GetProcessesByName(Process.GetCurrentProcess().ProcessName).Length > 1) {
                MessageBox.Show(Properties.Resources.isAlreadyRunning);
                return;
            } */
            
            //-- If a instance process of the program has been already runnung, show the UI of the process and exit.
            if (ActivateRunningProcess()) {
                return;
            }

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new Photostand());
        }

        // Activate the process, if a instance has been already running.
        private static bool ActivateRunningProcess()
        {
            string pnm = Process.GetCurrentProcess().ProcessName.ToString();
            string cls = "WindowsForms10.Window.8.app.0.33c0d9d";
            // string cls = null; //-- If not specified, other process like explorer opened with photostand folder may be matched.
            IntPtr hWnd = FindWindow(cls, pnm);
            if (hWnd == IntPtr.Zero) {
                //-- In debugging, the .vshost is added after the process name.
                string pnmr = pnm.Replace(".vshost", "");
                if (!pnmr.Equals(pnm)) {
                    hWnd = FindWindow(cls, pnmr);
                }
            }
            /* This may work, but can't get window handle when the process is in background.
            IntPtr hWnd = IntPtr.Zero;
            Process curProc = Process.GetCurrentProcess();
            string curProcName = curProc.ProcessName;
            Process[] procs = Process.GetProcessesByName(curProcName);
            foreach (Process proc in procs) {
                if (proc.Id != curProc.Id) {
                    hWnd = proc.MainWindowHandle;
                    break;
                }
            }
            if (hWnd == IntPtr.Zero) {
                curProcName = curProcName.Replace(".vshost", "");
                procs = Process.GetProcessesByName(curProcName);
                foreach (Process proc in procs) {
                    if (proc.Id != curProc.Id) {
                        hWnd = proc.MainWindowHandle;
                        break;
                    }
                }
            }
            */
            if (hWnd == IntPtr.Zero) {
                return false;
            }
            bool rts = ShowWindowAsync(hWnd, SW_RESTORE);
            bool rtf = SetForegroundWindow(hWnd);
            if (!rts || !rtf) {
                MessageBox.Show(Properties.Resources.isAlreadyRunning + "(" + (rts?"1":"0") + "," + (rtf?"1":"0") + ")");
            }
            return true;
        }

        [DllImport("user32.dll")]
        private static extern bool SetForegroundWindow(IntPtr hWnd);
        [DllImport("user32.dll")]
        private static extern IntPtr FindWindow(string lpClassName, string lpWindowName);
        [DllImport("user32.dll")]
        private static extern bool ShowWindowAsync(IntPtr hWnd, int nCmdShow);
        private const int SW_RESTORE = 9;  // Restore the window size
    }
}
